//       BC++ Builder 1.X
//       (c) 1997, 1998 THETA GmbH, e-mail theta@atnet.at
//
//       Visual controll for automatically saving/restoring of form position
//       Use with Borland C++ Builder 1.x
//
//       This code is Freeware. You may use it as you whish, as long as you
//       supply this file together with your code. Please mail any bugs or 
//       improvement wishes to theta@atnet.at
//
//       To install exract all files and in BC++ select
//       Component->Install->Add->Browse, and select
//       SavePos.obj	
//       Controll is installed under FreeWare in BC++ Builder palette
//
//       Usage: Just place controll on form and fill in two properites.
//       Registry key: under what key will adta be saved (allways in
//       HKEY_CURRENT_USER) and registry section. On every form create
//       controll will read window position/size and state from registry
//       and before destroy it will update the info. Keys wll allways begin
//       with parent form name. On first start (no keys yet) form will be
//       placed at (1,1) and size will be limited to screen size.
//       
//       Modification History:
//
//       1.0: initial release
// 
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "SavePos.h"
#include <vcl\registry.hpp>
//---------------------------------------------------------------------------
static inline TSavePosition *ValidCtrCheck()
{
   return new TSavePosition(NULL);
}
//---------------------------------------------------------------------------
__fastcall TSavePosition::TSavePosition(TComponent* Owner)
    : TComponent(Owner)
 {}

void __fastcall TSavePosition::Loaded(void)
{
   TForm *a;
   int b;

   // Do rest ONLY IF NOT in design mode! 
    if (!this->ComponentState.Contains(csDesigning)) { 
      a = (TForm *)Owner;
      this->Parent = Owner;

      TRegIniFile *RegFile = new TRegIniFile(this->RegEnt);
   
      // Try to read last windows settings
      a->Top    = RegFile->ReadInteger(RegSect,a->Name+"_TOP",1);
      a->Left   = RegFile->ReadInteger(RegSect,a->Name+"_LEFT",1);
      a->Width  = RegFile->ReadInteger(RegSect,a->Name+"_WIDTH",a->Width-10);
      a->Height = RegFile->ReadInteger(RegSect,a->Name+"_HEIGHT",a->Height-10);

      a->Width  = min(Screen->Width, a->Width);
      a->Height = min(Screen->Height,a->Height);

      b = RegFile->ReadInteger(RegSect,a->Name+"_STATE",0);   	// Read window state

      if (b)                        // Was it MAXIMIZED (default)??
         a->WindowState = wsMaximized;
      else
         a->WindowState = wsNormal;
   

      RegFile->Free();     
   } 
   
   // Call OLD loaded handler
   TComponent::Loaded();
   

}
//---------------------------------------------------------------------------

__fastcall TSavePosition::~TSavePosition(void)
{
   TForm *a;
   a = (TForm *)this->Parent;

   // Do rest ONLY IF NOT in design mode! 
   if (!this->ComponentState.Contains(csDesigning)) { 
      TRegIniFile *RegFile = new TRegIniFile(this->RegEnt);

      if (a->WindowState == wsMaximized)
         RegFile->WriteInteger(RegSect,a->Name+"_STATE",1);
      else {
         RegFile->WriteInteger(RegSect,a->Name+"_STATE",0);
         // DON'T SAVE POSITION IF MAXIMIZED !!!!
         RegFile->WriteInteger(RegSect,a->Name+"_TOP",a->Top);
         RegFile->WriteInteger(RegSect,a->Name+"_LEFT",a->Left);
         RegFile->WriteInteger(RegSect,a->Name+"_WIDTH",a->Width);
         RegFile->WriteInteger(RegSect,a->Name+"_HEIGHT",a->Height);
      }
      RegFile->Free();     
   }
   
}

namespace Savepos
{
   void __fastcall Register()
   {
      TComponentClass classes[1] = {__classid(TSavePosition)};
      RegisterComponents("FreeWare", classes, 0);
   }
}
//---------------------------------------------------------------------------
 